diff -Nur audacious-plugins-3.6-beta1-gtk3-orig/src/adplug/core/fmopl.cc audacious-plugins-3.6-beta1-gtk3/src/adplug/core/fmopl.cc
--- audacious-plugins-3.6-beta1-gtk3-orig/src/adplug/core/fmopl.cc	2015-01-24 20:29:27.000000000 +0100
+++ audacious-plugins-3.6-beta1-gtk3/src/adplug/core/fmopl.cc	2015-02-19 23:45:40.000000000 +0100
@@ -124,7 +124,7 @@
 /* key scale level */
 /* table is 3dB/OCT , DV converts this in TL step at 6dB/OCT */
 #define DV (EG_STEP/2)
-static const UINT32 KSL_TABLE[8*16]=
+static const double KSL_TABLE[8*16]=
 {
 	/* OCT 0 */
 	 0.000/DV, 0.000/DV, 0.000/DV, 0.000/DV,
@@ -172,7 +172,7 @@
 /* sustain lebel table (3db per step) */
 /* 0 - 15: 0, 3, 6, 9,12,15,18,21,24,27,30,33,36,39,42,93 (dB)*/
 #define SC(db) (db*((3/EG_STEP)*(1<<ENV_BITS)))+EG_DST
-static const INT32 SL_TABLE[16]={
+static const double SL_TABLE[16]={
  SC( 0),SC( 1),SC( 2),SC(3 ),SC(4 ),SC(5 ),SC(6 ),SC( 7),
  SC( 8),SC( 9),SC(10),SC(11),SC(12),SC(13),SC(14),SC(31)
 };
@@ -197,7 +197,7 @@
 
 /* multiple table */
 #define ML 2
-static const UINT32 MUL_TABLE[16]= {
+static const double MUL_TABLE[16]= {
 /* 1/2, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15 */
    0.50*ML, 1.00*ML, 2.00*ML, 3.00*ML, 4.00*ML, 5.00*ML, 6.00*ML, 7.00*ML,
    8.00*ML, 9.00*ML,10.00*ML,10.00*ML,12.00*ML,12.00*ML,15.00*ML,15.00*ML
@@ -392,7 +392,7 @@
 	OPL_CH   *CH   = &OPL->P_CH[slot/2];
 	OPL_SLOT *SLOT = &CH->SLOT[slot&1];
 
-	SLOT->mul    = MUL_TABLE[v&0x0f];
+	SLOT->mul    = static_cast<UINT32>(MUL_TABLE[v&0x0f]);
 	SLOT->KSR    = (v&0x10) ? 0 : 2;
 	SLOT->eg_typ = (v&0x20)>>5;
 	SLOT->vib    = (v&0x40);
@@ -441,7 +441,7 @@
 	int sl = v>>4;
 	int rr = v & 0x0f;
 
-	SLOT->SL = SL_TABLE[sl];
+	SLOT->SL = static_cast<INT32>(SL_TABLE[sl]);
 	if( SLOT->evm == ENV_MOD_DR ) SLOT->eve = SLOT->SL;
 	SLOT->RR = &OPL->DR_TABLE[rr<<2];
 	SLOT->evsr = SLOT->RR[SLOT->ksr];
@@ -977,7 +977,7 @@
 			int fnum   = block_fnum&0x3ff;
 			CH->block_fnum = block_fnum;
 
-			CH->ksl_base = KSL_TABLE[block_fnum>>6];
+			CH->ksl_base = static_cast<UINT32>(KSL_TABLE[block_fnum>>6]);
 			CH->fc = OPL->FN_TABLE[fnum]>>blockRv;
 			CH->kcode = CH->block_fnum>>9;
 			if( (OPL->mode&0x40) && CH->block_fnum&0x100) CH->kcode |=1;
diff -Nur audacious-plugins-3.6-beta1-gtk3-orig/src/psf/psx.cc audacious-plugins-3.6-beta1-gtk3/src/psf/psx.cc
--- audacious-plugins-3.6-beta1-gtk3-orig/src/psf/psx.cc	2015-01-24 20:29:27.000000000 +0100
+++ audacious-plugins-3.6-beta1-gtk3/src/psf/psx.cc	2015-02-19 23:18:56.000000000 +0100
@@ -72,76 +72,76 @@
 
 static uint8_t mips_reg_layout[] =
 {
-	MIPS_PC, -1,
-	MIPS_DELAYV, MIPS_DELAYR, -1,
-	MIPS_HI, MIPS_LO, -1,
-	-1,
-	MIPS_R0, MIPS_R1, -1,
-	MIPS_R2, MIPS_R3, -1,
-	MIPS_R4, MIPS_R5, -1,
-	MIPS_R6, MIPS_R7, -1,
-	MIPS_R8, MIPS_R9, -1,
-	MIPS_R10, MIPS_R11, -1,
-	MIPS_R12, MIPS_R13, -1,
-	MIPS_R14, MIPS_R15, -1,
-	MIPS_R16, MIPS_R17, -1,
-	MIPS_R18, MIPS_R19, -1,
-	MIPS_R20, MIPS_R21, -1,
-	MIPS_R22, MIPS_R23, -1,
-	MIPS_R24, MIPS_R25, -1,
-	MIPS_R26, MIPS_R27, -1,
-	MIPS_R28, MIPS_R29, -1,
-	MIPS_R30, MIPS_R31, -1,
-	-1,
-	MIPS_CP0R0, MIPS_CP0R1, -1,
-	MIPS_CP0R2, MIPS_CP0R3, -1,
-	MIPS_CP0R4, MIPS_CP0R5, -1,
-	MIPS_CP0R6, MIPS_CP0R7, -1,
-	MIPS_CP0R8, MIPS_CP0R9, -1,
-	MIPS_CP0R10, MIPS_CP0R11, -1,
-	MIPS_CP0R12, MIPS_CP0R13, -1,
-	MIPS_CP0R14, MIPS_CP0R15, -1,
-	MIPS_CP0R16, MIPS_CP0R17, -1,
-	MIPS_CP0R18, MIPS_CP0R19, -1,
-	MIPS_CP0R20, MIPS_CP0R21, -1,
-	MIPS_CP0R22, MIPS_CP0R23, -1,
-	MIPS_CP0R24, MIPS_CP0R25, -1,
-	MIPS_CP0R26, MIPS_CP0R27, -1,
-	MIPS_CP0R28, MIPS_CP0R29, -1,
-	MIPS_CP0R30, MIPS_CP0R31, -1,
-	-1,
-	MIPS_CP2DR0, MIPS_CP2DR1, -1,
-	MIPS_CP2DR2, MIPS_CP2DR3, -1,
-	MIPS_CP2DR4, MIPS_CP2DR5, -1,
-	MIPS_CP2DR6, MIPS_CP2DR7, -1,
-	MIPS_CP2DR8, MIPS_CP2DR9, -1,
-	MIPS_CP2DR10, MIPS_CP2DR11, -1,
-	MIPS_CP2DR12, MIPS_CP2DR13, -1,
-	MIPS_CP2DR14, MIPS_CP2DR15, -1,
-	MIPS_CP2DR16, MIPS_CP2DR17, -1,
-	MIPS_CP2DR18, MIPS_CP2DR19, -1,
-	MIPS_CP2DR20, MIPS_CP2DR21, -1,
-	MIPS_CP2DR22, MIPS_CP2DR23, -1,
-	MIPS_CP2DR24, MIPS_CP2DR25, -1,
-	MIPS_CP2DR26, MIPS_CP2DR27, -1,
-	MIPS_CP2DR28, MIPS_CP2DR29, -1,
-	MIPS_CP2DR30, MIPS_CP2DR31, -1,
-	-1,
-	MIPS_CP2CR0, MIPS_CP2CR1, -1,
-	MIPS_CP2CR2, MIPS_CP2CR3, -1,
-	MIPS_CP2CR4, MIPS_CP2CR5, -1,
-	MIPS_CP2CR6, MIPS_CP2CR7, -1,
-	MIPS_CP2CR8, MIPS_CP2CR9, -1,
-	MIPS_CP2CR10, MIPS_CP2CR11, -1,
-	MIPS_CP2CR12, MIPS_CP2CR13, -1,
-	MIPS_CP2CR14, MIPS_CP2CR15, -1,
-	MIPS_CP2CR16, MIPS_CP2CR17, -1,
-	MIPS_CP2CR18, MIPS_CP2CR19, -1,
-	MIPS_CP2CR20, MIPS_CP2CR21, -1,
-	MIPS_CP2CR22, MIPS_CP2CR23, -1,
-	MIPS_CP2CR24, MIPS_CP2CR25, -1,
-	MIPS_CP2CR26, MIPS_CP2CR27, -1,
-	MIPS_CP2CR28, MIPS_CP2CR29, -1,
+	MIPS_PC, 0xFF,
+	MIPS_DELAYV, MIPS_DELAYR, 0xFF,
+	MIPS_HI, MIPS_LO, 0xFF,
+	0xFF,
+	MIPS_R0, MIPS_R1, 0xFF,
+	MIPS_R2, MIPS_R3, 0xFF,
+	MIPS_R4, MIPS_R5, 0xFF,
+	MIPS_R6, MIPS_R7, 0xFF,
+	MIPS_R8, MIPS_R9, 0xFF,
+	MIPS_R10, MIPS_R11, 0xFF,
+	MIPS_R12, MIPS_R13, 0xFF,
+	MIPS_R14, MIPS_R15, 0xFF,
+	MIPS_R16, MIPS_R17, 0xFF,
+	MIPS_R18, MIPS_R19, 0xFF,
+	MIPS_R20, MIPS_R21, 0xFF,
+	MIPS_R22, MIPS_R23, 0xFF,
+	MIPS_R24, MIPS_R25, 0xFF,
+	MIPS_R26, MIPS_R27, 0xFF,
+	MIPS_R28, MIPS_R29, 0xFF,
+	MIPS_R30, MIPS_R31, 0xFF,
+	0xFF,
+	MIPS_CP0R0, MIPS_CP0R1, 0xFF,
+	MIPS_CP0R2, MIPS_CP0R3, 0xFF,
+	MIPS_CP0R4, MIPS_CP0R5, 0xFF,
+	MIPS_CP0R6, MIPS_CP0R7, 0xFF,
+	MIPS_CP0R8, MIPS_CP0R9, 0xFF,
+	MIPS_CP0R10, MIPS_CP0R11, 0xFF,
+	MIPS_CP0R12, MIPS_CP0R13, 0xFF,
+	MIPS_CP0R14, MIPS_CP0R15, 0xFF,
+	MIPS_CP0R16, MIPS_CP0R17, 0xFF,
+	MIPS_CP0R18, MIPS_CP0R19, 0xFF,
+	MIPS_CP0R20, MIPS_CP0R21, 0xFF,
+	MIPS_CP0R22, MIPS_CP0R23, 0xFF,
+	MIPS_CP0R24, MIPS_CP0R25, 0xFF,
+	MIPS_CP0R26, MIPS_CP0R27, 0xFF,
+	MIPS_CP0R28, MIPS_CP0R29, 0xFF,
+	MIPS_CP0R30, MIPS_CP0R31, 0xFF,
+	0xFF,
+	MIPS_CP2DR0, MIPS_CP2DR1, 0xFF,
+	MIPS_CP2DR2, MIPS_CP2DR3, 0xFF,
+	MIPS_CP2DR4, MIPS_CP2DR5, 0xFF,
+	MIPS_CP2DR6, MIPS_CP2DR7, 0xFF,
+	MIPS_CP2DR8, MIPS_CP2DR9, 0xFF,
+	MIPS_CP2DR10, MIPS_CP2DR11, 0xFF,
+	MIPS_CP2DR12, MIPS_CP2DR13, 0xFF,
+	MIPS_CP2DR14, MIPS_CP2DR15, 0xFF,
+	MIPS_CP2DR16, MIPS_CP2DR17, 0xFF,
+	MIPS_CP2DR18, MIPS_CP2DR19, 0xFF,
+	MIPS_CP2DR20, MIPS_CP2DR21, 0xFF,
+	MIPS_CP2DR22, MIPS_CP2DR23, 0xFF,
+	MIPS_CP2DR24, MIPS_CP2DR25, 0xFF,
+	MIPS_CP2DR26, MIPS_CP2DR27, 0xFF,
+	MIPS_CP2DR28, MIPS_CP2DR29, 0xFF,
+	MIPS_CP2DR30, MIPS_CP2DR31, 0xFF,
+	0xFF,
+	MIPS_CP2CR0, MIPS_CP2CR1, 0xFF,
+	MIPS_CP2CR2, MIPS_CP2CR3, 0xFF,
+	MIPS_CP2CR4, MIPS_CP2CR5, 0xFF,
+	MIPS_CP2CR6, MIPS_CP2CR7, 0xFF,
+	MIPS_CP2CR8, MIPS_CP2CR9, 0xFF,
+	MIPS_CP2CR10, MIPS_CP2CR11, 0xFF,
+	MIPS_CP2CR12, MIPS_CP2CR13, 0xFF,
+	MIPS_CP2CR14, MIPS_CP2CR15, 0xFF,
+	MIPS_CP2CR16, MIPS_CP2CR17, 0xFF,
+	MIPS_CP2CR18, MIPS_CP2CR19, 0xFF,
+	MIPS_CP2CR20, MIPS_CP2CR21, 0xFF,
+	MIPS_CP2CR22, MIPS_CP2CR23, 0xFF,
+	MIPS_CP2CR24, MIPS_CP2CR25, 0xFF,
+	MIPS_CP2CR26, MIPS_CP2CR27, 0xFF,
+	MIPS_CP2CR28, MIPS_CP2CR29, 0xFF,
 	MIPS_CP2CR30, MIPS_CP2CR31,
 	0
 };